require 'dp/parser'

def dp_type_dump(dp_type)
  print dp_type.ident, ' '
  dp_class = dp_type.value
  if dp_class.respond_to? :herit
    print '=', ' '
    print '(', dp_class.herit, ')'
  end
  print "\n"
  if dp_class.respond_to? :field_list
    dp_class.field_list.each do |visib, field|
      print "\t"
      print visib, ' '
    # p field
      dp_field = field
      if dp_field
         print dp_field.ident
         print '(', dp_field.param_list, ')', ':', ' '
         print dp_field.dtype, ';'
      end
      print "\n"
    end
  end
end

unitname = 'StdCtrls'
unitdir = 'D:/Borland/Delphi6/Source/Vcl'
unitfname = "#{unitdir}/#{unitname}.pas"

dp = Delphi::Parser.new
dp.load(unitfname)

dp_classname = 'TEdit'
dp_fieldname = 'Font'

dp.on_uses = proc do |uname|
  p uname
  dp_unit = Marshal.load(open("dpi/#{uname}.dpi", "rb"))
  dp_unit.interface.types.each do |dp_type|
    dp_type_dump(dp_type)
  end
end

dp.on_type_decl = proc do |dp_type|
  # dp_type.class == Delphi::Type
  # next if dp_type.ident != dp_classname
  dp_type_dump(dp_type)
end

dp.parse_interface
