require 'dp/structure'

def dp_type_dump(dp_type)
  print dp_type.ident, ' '
  dp_class = dp_type.value
  if dp_class.respond_to? :herit
    print '=', ' '
    print '(', dp_class.herit.join(', '), ')' if dp_class.herit
  end
  print "\n"
  if dp_class.respond_to? :field_list
    dp_class.field_list.each do |visib, field|
      print "\t"
      print visib, ' '
    # p field
      dp_field = field
      if dp_field
         print dp_field.ident
         print '(', dp_field.param_list, ')', ':', ' '
         print dp_field.dtype, ';'
      end
      print "\n"
    end
  end
end

@units = {}

def unit_loaded(uname, unit)
  @units[uname] = unit
end

def unit_loaded?(uname)
  @units[uname]
end

def dp_unit_dump(uname)
  dp_unit = Marshal.load(open("dpi/#{uname}.dpi", "rb"))
  unit_loaded(uname, dp_unit)
  dp_unit.interface.uses.each do |uname|
    dp_unit_dump(uname) unless unit_loaded?(uname)
  end
  puts "unit=#{uname}"
  dp_unit.interface.types.each do |dp_type|
    dp_type_dump(dp_type)
  end
end

uname = 'StdCtrls'
dp_unit_dump(uname)

dp_classname = 'TEdit'
dp_fieldname = 'Font'
